/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GLUTIL_H
#define GLINT_GLUTIL_H

#include <string>
#include <glint/OpenGL.h>

namespace glint
{

std::string gl_err_to_name(GLenum gl_err); // Translates enum to corresponding string
void check_gl(const std::string& msg);     // Checks for GL errors and throws if there is an error

//
// Calls glGetError() in a loop until glGetError() returns GL_NO_ERROR.
// The return value is the FIRST error returned by glGetError(), GL_NO_ERROR if there was no error.
//

GLenum clear_gl_error();

} // namespace glint

#endif
