/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_TYPES_H
#define GLINT_TYPES_H

#include <glint/OpenGL.h>

#include <array>
#include <vector>

namespace glint
{

typedef std::array<GLfloat, 2> FloatVec2;
typedef std::array<GLfloat, 3> FloatVec3;
typedef std::array<GLfloat, 4> FloatVec4;

typedef std::array<FloatVec2, 2> FloatMat2;
typedef std::array<FloatVec3, 3> FloatMat3;
typedef std::array<FloatVec4, 4> FloatMat4;

typedef std::vector<GLfloat> FloatArray;

typedef std::vector<FloatVec2> FloatVec2Array;
typedef std::vector<FloatVec3> FloatVec3Array;
typedef std::vector<FloatVec4> FloatVec4Array;

typedef std::vector<FloatMat2> FloatMat2Array;
typedef std::vector<FloatMat3> FloatMat3Array;
typedef std::vector<FloatMat4> FloatMat4Array;

typedef std::array<GLint, 2> IntVec2;
typedef std::array<GLint, 3> IntVec3;
typedef std::array<GLint, 4> IntVec4;

typedef std::vector<GLint> IntArray;

typedef std::vector<IntVec2> IntVec2Array;
typedef std::vector<IntVec3> IntVec3Array;
typedef std::vector<IntVec4> IntVec4Array;

typedef std::array<GLboolean, 2> BoolVec2;
typedef std::array<GLboolean, 3> BoolVec3;
typedef std::array<GLboolean, 4> BoolVec4;

typedef std::vector<GLboolean> BoolArray;

typedef std::vector<BoolVec2> BoolVec2Array;
typedef std::vector<BoolVec3> BoolVec3Array;
typedef std::vector<BoolVec4> BoolVec4Array;

typedef std::vector<GLint> Sampler2DArray;
typedef std::vector<GLint> SamplerCubeArray;

} // namespace glint

#endif
