/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENVEXCEPTION_H
#define GLINT_GENVEXCEPTION_H

#include <glint/Exception.h>

#include <exception>
#include <string>
#include <memory>

namespace glint
{

namespace genv
{

namespace internal
{
class GEnvExceptionImpl;
}

//
// Abstract base exception for errors from the graphic environments (glX, glW, and so on).
//

class GEnvException : public glint::Exception
{
public:
    GEnvException(const GEnvException&);
    GEnvException& operator=(const GEnvException&);
    virtual ~GEnvException() noexcept;

    virtual const char* what() const noexcept = 0;
    virtual std::exception_ptr self() const = 0;

protected:
    explicit GEnvException(const std::shared_ptr<glint::genv::internal::GEnvExceptionImpl>& derived);
};

} // namespace genv

} // namespace glint

#endif
