/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENV_EGL_EGLEXCEPTION_H
#define GLINT_GENV_EGL_EGLEXCEPTION_H

#include <glint/genv/GEnvException.h>

#include <EGL/egl.h>

namespace glint
{

namespace genv
{

namespace egl
{

namespace internal
{
class EGLExceptionImpl;
}

//
// Exception for EGL environment errors.
//

class EGLException : public GEnvException
{
public:
    explicit EGLException(const std::string& reason, EGLint egl_error = eglGetError());
    EGLException(const EGLException&);
    EGLException& operator=(const EGLException&);
    ~EGLException() noexcept;

    virtual const char* what() const noexcept;
    virtual std::string reason() const;
    virtual std::exception_ptr self() const;

    EGLint egl_error() const noexcept;
};

} // namespace egl

} // namespace genv

} // namespace glint

#endif
