/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENV_EGL_INTERNAL_EGLEXCEPTIONIMPL_H
#define GLINT_GENV_EGL_INTERNAL_EGLEXCEPTIONIMPL_H

#include <glint/genv/egl/EGLException.h>
#include <glint/genv/internal/GEnvExceptionImpl.h>

#include <string>
#include <exception>

namespace glint
{

namespace genv
{

namespace egl
{

namespace internal
{

class EGLExceptionImpl : public glint::genv::internal::GEnvExceptionImpl
{
public:
    EGLExceptionImpl(const std::string& reason, int egl_error);

    virtual const char* what() const noexcept;
    virtual std::string reason() const;

    int egl_error() const noexcept;

private:
    int egl_error_;

    std::string egl_error_string() const;
};

} // namespace internal

} // namespace EGL

} // namespace genv

} // namespace glint

#endif
