/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENV_X11_X11EXCEPTION_H
#define GLINT_GENV_X11_X11EXCEPTION_H

#include <glint/genv/GEnvException.h>

namespace glint
{

namespace genv
{

namespace x11
{

namespace internal
{
class X11ExceptionImpl;
}

//
// Exception for X11 errors.
//

class X11Exception : public GEnvException
{
public:
    explicit X11Exception(const std::string& reason);
    X11Exception(const X11Exception&);
    X11Exception& operator=(const X11Exception&);
    ~X11Exception() noexcept;

    virtual const char* what() const noexcept;
    virtual std::exception_ptr self() const;
};

} // namespace x11

} // namespace genv

} // namespace glint

#endif
