/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENV_X11_X11WINDOW_H
#define GLINT_GENV_X11_X11WINDOW_H

#include <glint/AbstractWindow.h>

#include <X11/Xlib.h>

#include <memory>

namespace glint
{

namespace genv
{

namespace x11
{

namespace internal
{
class X11WindowImpl;
}

class X11Window : public glint::AbstractWindow
{
public:
    X11Window(Display* display, Window window);
    virtual ~X11Window() noexcept;

    virtual Display* display() const noexcept;
    virtual Window window() const noexcept;

private:
    std::shared_ptr<internal::X11WindowImpl> p_;
};

} // namespace x11

} // namespace genv

} // namespace glint

#endif
