/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENV_X11_INTERNAL_X11EXCEPTIONIMPL_H
#define GLINT_GENV_X11_INTERNAL_X11EXCEPTIONIMPL_H

#include <glint/genv/x11/X11Exception.h>
#include <glint/genv/internal/GEnvExceptionImpl.h>

#include <string>
#include <exception>

namespace glint
{

namespace genv
{

namespace x11
{

namespace internal
{

class X11ExceptionImpl : public glint::genv::internal::GEnvExceptionImpl
{
public:
    X11ExceptionImpl(const std::string& reason);

    virtual const char* what() const noexcept;
};

} // namespace internal

} // namespace x11

} // namespace genv

} // namespace glint

#endif
