/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#ifndef GLINT_GENV_X11_INTERNAL_X11WINDOWIMPL_H
#define GLINT_GENV_X11_INTERNAL_X11WINDOWIMPL_H

#include <glint/genv/x11/X11Window.h>

namespace glint
{

namespace genv
{

namespace x11
{

namespace internal
{

class X11WindowImpl
{
public:
    X11WindowImpl(Display* display, Window window);
    ~X11WindowImpl() noexcept;

    Display* display() const noexcept;
    Window window() const noexcept;

private:
    Display* display_;
    Window window_;
};

} // namespace internal

} // namespace x11

} // namespace genv

} // namespace glint

#endif
