/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/ColorNames.h>

#include <map>

using namespace glint;
using namespace std;

namespace glint
{

const map<string, SVGColor> SVG_colors =
{
    pair<const char*, SVGColor>("aliceblue",            SVGColor::aliceblue),
    pair<const char*, SVGColor>("antiquewhite",         SVGColor::antiquewhite),
    pair<const char*, SVGColor>("aqua",                 SVGColor::aqua),
    pair<const char*, SVGColor>("aquamarine",           SVGColor::aquamarine),
    pair<const char*, SVGColor>("azure",                SVGColor::azure),
    pair<const char*, SVGColor>("beige",                SVGColor::beige),
    pair<const char*, SVGColor>("bisque",               SVGColor::bisque),
    pair<const char*, SVGColor>("black",                SVGColor::black),
    pair<const char*, SVGColor>("blanchedalmond",       SVGColor::blanchedalmond),
    pair<const char*, SVGColor>("blue",                 SVGColor::blue),
    pair<const char*, SVGColor>("blueviolet",           SVGColor::blueviolet),
    pair<const char*, SVGColor>("brown",                SVGColor::brown),
    pair<const char*, SVGColor>("burlywood",            SVGColor::burlywood),
    pair<const char*, SVGColor>("cadetblue",            SVGColor::cadetblue),
    pair<const char*, SVGColor>("chartreuse",           SVGColor::chartreuse),
    pair<const char*, SVGColor>("chocolate",            SVGColor::chocolate),
    pair<const char*, SVGColor>("coral",                SVGColor::coral),
    pair<const char*, SVGColor>("cornflowerblue",       SVGColor::cornflowerblue),
    pair<const char*, SVGColor>("cornsilk",             SVGColor::cornsilk),
    pair<const char*, SVGColor>("crimson",              SVGColor::crimson),
    pair<const char*, SVGColor>("cyan",                 SVGColor::cyan),
    pair<const char*, SVGColor>("darkblue",             SVGColor::darkblue),
    pair<const char*, SVGColor>("darkcyan",             SVGColor::darkcyan),
    pair<const char*, SVGColor>("darkgoldenrod",        SVGColor::darkgoldenrod),
    pair<const char*, SVGColor>("darkgray",             SVGColor::darkgray),
    pair<const char*, SVGColor>("darkgreen",            SVGColor::darkgreen),
    pair<const char*, SVGColor>("darkgrey",             SVGColor::darkgrey),
    pair<const char*, SVGColor>("darkkhaki",            SVGColor::darkkhaki),
    pair<const char*, SVGColor>("darkmagenta",          SVGColor::darkmagenta),
    pair<const char*, SVGColor>("darkolivegreen",       SVGColor::darkolivegreen),
    pair<const char*, SVGColor>("darkorange",           SVGColor::darkorange),
    pair<const char*, SVGColor>("darkorchid",           SVGColor::darkorchid),
    pair<const char*, SVGColor>("darkred",              SVGColor::darkred),
    pair<const char*, SVGColor>("darksalmon",           SVGColor::darksalmon),
    pair<const char*, SVGColor>("darkseagreen",         SVGColor::darkseagreen),
    pair<const char*, SVGColor>("darkslateblue",        SVGColor::darkslateblue),
    pair<const char*, SVGColor>("darkslategray",        SVGColor::darkslategray),
    pair<const char*, SVGColor>("darkslategrey",        SVGColor::darkslategrey),
    pair<const char*, SVGColor>("darkturquoise",        SVGColor::darkturquoise),
    pair<const char*, SVGColor>("darkviolet",           SVGColor::darkviolet),
    pair<const char*, SVGColor>("deeppink",             SVGColor::deeppink),
    pair<const char*, SVGColor>("deepskyblue",          SVGColor::deepskyblue),
    pair<const char*, SVGColor>("dimgray",              SVGColor::dimgray),
    pair<const char*, SVGColor>("dimgrey",              SVGColor::dimgrey),
    pair<const char*, SVGColor>("dodgerblue",           SVGColor::dodgerblue),
    pair<const char*, SVGColor>("firebrick",            SVGColor::firebrick),
    pair<const char*, SVGColor>("floralwhite",          SVGColor::floralwhite),
    pair<const char*, SVGColor>("forestgreen",          SVGColor::forestgreen),
    pair<const char*, SVGColor>("fuchsia",              SVGColor::fuchsia),
    pair<const char*, SVGColor>("gainsboro",            SVGColor::gainsboro),
    pair<const char*, SVGColor>("ghostwhite",           SVGColor::ghostwhite),
    pair<const char*, SVGColor>("gold",                 SVGColor::gold),
    pair<const char*, SVGColor>("goldenrod",            SVGColor::goldenrod),
    pair<const char*, SVGColor>("gray",                 SVGColor::gray),
    pair<const char*, SVGColor>("grey",                 SVGColor::grey),
    pair<const char*, SVGColor>("green",                SVGColor::green),
    pair<const char*, SVGColor>("greenyellow",          SVGColor::greenyellow),
    pair<const char*, SVGColor>("honeydew",             SVGColor::honeydew),
    pair<const char*, SVGColor>("hotpink",              SVGColor::hotpink),
    pair<const char*, SVGColor>("indianred",            SVGColor::indianred),
    pair<const char*, SVGColor>("indigo",               SVGColor::indigo),
    pair<const char*, SVGColor>("ivory",                SVGColor::ivory),
    pair<const char*, SVGColor>("khaki",                SVGColor::khaki),
    pair<const char*, SVGColor>("lavender",             SVGColor::lavender),
    pair<const char*, SVGColor>("lavenderblush",        SVGColor::lavenderblush),
    pair<const char*, SVGColor>("lawngreen",            SVGColor::lawngreen),
    pair<const char*, SVGColor>("lemonchiffon",         SVGColor::lemonchiffon),
    pair<const char*, SVGColor>("lightblue",            SVGColor::lightblue),
    pair<const char*, SVGColor>("lightcoral",           SVGColor::lightcoral),
    pair<const char*, SVGColor>("lightcyan",            SVGColor::lightcyan),
    pair<const char*, SVGColor>("lightgoldenrodyellow", SVGColor::lightgoldenrodyellow),
    pair<const char*, SVGColor>("lightgray",            SVGColor::lightgray),
    pair<const char*, SVGColor>("lightgreen",           SVGColor::lightgreen),
    pair<const char*, SVGColor>("lightgrey",            SVGColor::lightgrey),
    pair<const char*, SVGColor>("lightpink",            SVGColor::lightpink),
    pair<const char*, SVGColor>("lightsalmon",          SVGColor::lightsalmon),
    pair<const char*, SVGColor>("lightseagreen",        SVGColor::lightseagreen),
    pair<const char*, SVGColor>("lightskyblue",         SVGColor::lightskyblue),
    pair<const char*, SVGColor>("lightslategray",       SVGColor::lightslategray),
    pair<const char*, SVGColor>("lightslategrey",       SVGColor::lightslategrey),
    pair<const char*, SVGColor>("lightsteelblue",       SVGColor::lightsteelblue),
    pair<const char*, SVGColor>("lightyellow",          SVGColor::lightyellow),
    pair<const char*, SVGColor>("lime",                 SVGColor::lime),
    pair<const char*, SVGColor>("limegreen",            SVGColor::limegreen),
    pair<const char*, SVGColor>("linen",                SVGColor::linen),
    pair<const char*, SVGColor>("magenta",              SVGColor::magenta),
    pair<const char*, SVGColor>("maroon",               SVGColor::maroon),
    pair<const char*, SVGColor>("mediumaquamarine",     SVGColor::mediumaquamarine),
    pair<const char*, SVGColor>("mediumblue",           SVGColor::mediumblue),
    pair<const char*, SVGColor>("mediumorchid",         SVGColor::mediumorchid),
    pair<const char*, SVGColor>("mediumpurple",         SVGColor::mediumpurple),
    pair<const char*, SVGColor>("mediumseagreen",       SVGColor::mediumseagreen),
    pair<const char*, SVGColor>("mediumslateblue",      SVGColor::mediumslateblue),
    pair<const char*, SVGColor>("mediumspringgreen",    SVGColor::mediumspringgreen),
    pair<const char*, SVGColor>("mediumturquoise",      SVGColor::mediumturquoise),
    pair<const char*, SVGColor>("mediumvioletred",      SVGColor::mediumvioletred),
    pair<const char*, SVGColor>("midnightblue",         SVGColor::midnightblue),
    pair<const char*, SVGColor>("mintcream",            SVGColor::mintcream),
    pair<const char*, SVGColor>("mistyrose",            SVGColor::mistyrose),
    pair<const char*, SVGColor>("moccasin",             SVGColor::moccasin),
    pair<const char*, SVGColor>("navajowhite",          SVGColor::navajowhite),
    pair<const char*, SVGColor>("navy",                 SVGColor::navy),
    pair<const char*, SVGColor>("oldlace",              SVGColor::oldlace),
    pair<const char*, SVGColor>("olive",                SVGColor::olive),
    pair<const char*, SVGColor>("olivedrab",            SVGColor::olivedrab),
    pair<const char*, SVGColor>("orange",               SVGColor::orange),
    pair<const char*, SVGColor>("orangered",            SVGColor::orangered),
    pair<const char*, SVGColor>("orchid",               SVGColor::orchid),
    pair<const char*, SVGColor>("palegoldenrod",        SVGColor::palegoldenrod),
    pair<const char*, SVGColor>("palegreen",            SVGColor::palegreen),
    pair<const char*, SVGColor>("paleturquoise",        SVGColor::paleturquoise),
    pair<const char*, SVGColor>("palevioletred",        SVGColor::palevioletred),
    pair<const char*, SVGColor>("papayawhip",           SVGColor::papayawhip),
    pair<const char*, SVGColor>("peachpuff",            SVGColor::peachpuff),
    pair<const char*, SVGColor>("peru",                 SVGColor::peru),
    pair<const char*, SVGColor>("pink",                 SVGColor::pink),
    pair<const char*, SVGColor>("plum",                 SVGColor::plum),
    pair<const char*, SVGColor>("powderblue",           SVGColor::powderblue),
    pair<const char*, SVGColor>("purple",               SVGColor::purple),
    pair<const char*, SVGColor>("red",                  SVGColor::red),
    pair<const char*, SVGColor>("rosybrown",            SVGColor::rosybrown),
    pair<const char*, SVGColor>("royalblue",            SVGColor::royalblue),
    pair<const char*, SVGColor>("saddlebrown",          SVGColor::saddlebrown),
    pair<const char*, SVGColor>("salmon",               SVGColor::salmon),
    pair<const char*, SVGColor>("sandybrown",           SVGColor::sandybrown),
    pair<const char*, SVGColor>("seagreen",             SVGColor::seagreen),
    pair<const char*, SVGColor>("seashell",             SVGColor::seashell),
    pair<const char*, SVGColor>("sienna",               SVGColor::sienna),
    pair<const char*, SVGColor>("silver",               SVGColor::silver),
    pair<const char*, SVGColor>("skyblue",              SVGColor::skyblue),
    pair<const char*, SVGColor>("slateblue",            SVGColor::slateblue),
    pair<const char*, SVGColor>("slategray",            SVGColor::slategray),
    pair<const char*, SVGColor>("slategrey",            SVGColor::slategrey),
    pair<const char*, SVGColor>("snow",                 SVGColor::snow),
    pair<const char*, SVGColor>("springgreen",          SVGColor::springgreen),
    pair<const char*, SVGColor>("steelblue",            SVGColor::steelblue),
    pair<const char*, SVGColor>("tan",                  SVGColor::tan),
    pair<const char*, SVGColor>("teal",                 SVGColor::teal),
    pair<const char*, SVGColor>("thistle",              SVGColor::thistle),
    pair<const char*, SVGColor>("tomato",               SVGColor::tomato),
    pair<const char*, SVGColor>("turquoise",            SVGColor::turquoise),
    pair<const char*, SVGColor>("violet",               SVGColor::violet),
    pair<const char*, SVGColor>("wheat",                SVGColor::wheat),
    pair<const char*, SVGColor>("white",                SVGColor::white),
    pair<const char*, SVGColor>("whitesmoke",           SVGColor::whitesmoke),
    pair<const char*, SVGColor>("yellow",               SVGColor::yellow),
    pair<const char*, SVGColor>("yellowgreen",          SVGColor::yellowgreen)
};

} // namespace glint
