/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/ShaderVariable.h>
#include <glint/internal/ShaderVariableImpl.h>

using namespace glint;
using namespace std;

namespace glint
{

ShaderVariable::
ShaderVariable(const shared_ptr<internal::ShaderVariableImpl>& derived)
    : p_(derived)
{
}

ShaderVariable::
~ShaderVariable() = default;

GLuint
ShaderVariable::
program_id() const noexcept
{
    return p_->program_id();
}

GLint
ShaderVariable::
location() const noexcept
{
    return p_->location();
}

string
ShaderVariable::
name() const noexcept
{
    return p_->name();
}

GLenum
ShaderVariable::
type() const noexcept
{
    return p_->type();
}

GLint
ShaderVariable::
size() const noexcept
{
    return p_->size();
}

shared_ptr<internal::ShaderVariableImpl>
ShaderVariable::
pimpl() const noexcept
{
    return p_;
}
} // namespace glint
