/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/genv/GEnvException.h>
#include <glint/genv/internal/GEnvExceptionImpl.h>

using namespace std;

namespace glint
{

namespace genv
{

GEnvException::
GEnvException(const shared_ptr<glint::genv::internal::GEnvExceptionImpl>& derived)
    : Exception(derived)
{
}

GEnvException::
GEnvException(const GEnvException&) = default;

GEnvException&
GEnvException::
operator=(const GEnvException&) = default;

GEnvException::
~GEnvException() noexcept = default;

} // namespace genv

} // namespace glint
