/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/Exception.h>
#include <glint/genv/x11/internal/X11ExceptionImpl.h>

using namespace std;

namespace glint
{

namespace genv
{

namespace x11
{

X11Exception::
X11Exception(const string& reason)
    : GEnvException(make_shared<glint::genv::x11::internal::X11ExceptionImpl>(reason))
{
}

X11Exception::
X11Exception(const X11Exception&) = default;

X11Exception&
X11Exception::
operator=(const X11Exception&) = default;

X11Exception::
~X11Exception() noexcept = default;

const char*
X11Exception::
what() const noexcept
{
    return dynamic_pointer_cast<internal::X11ExceptionImpl>(pimpl())->what();
}

exception_ptr
X11Exception::
self() const
{
    return make_exception_ptr(*this);
}

} // namespace x11

} // namespace genv

} // namesapce glint
