/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/genv/x11/X11Window.h>
#include <glint/genv/x11/internal/X11WindowImpl.h>

using namespace std;

namespace glint
{

namespace genv
{

namespace x11
{

X11Window::
X11Window(Display* display, Window window)
    : p_(make_shared<internal::X11WindowImpl>(display, window))
{
}

X11Window::
~X11Window() noexcept
{
}

Display*
X11Window::
display() const noexcept
{
    return p_->display();
}

Window
X11Window::
window() const noexcept
{
    return p_->window();
}

} // namespace x11

} // namespace genv

} // namesapce glint
