/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/genv/x11/internal/X11WindowImpl.h>

using namespace std;

namespace glint
{

namespace genv
{

namespace x11
{

namespace internal
{

X11WindowImpl::
X11WindowImpl(Display* display, Window window)
    : display_(display), window_(window)
{
}

X11WindowImpl::
~X11WindowImpl() noexcept
{
}

Display*
X11WindowImpl::
display() const noexcept
{
    return display_;
}

Window
X11WindowImpl::
window() const noexcept
{
    return window_;
}

} // namespace internal

} // namespace x11

} // namespace genv

} // namespace glint
