/*
 * Copyright (C) 2012 Canonical Ltd
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 3 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by: Michi Henning <michi.henning@canonical.com>
 */

#include <glint/Runtime.h>
#include <glint/GraphicsDisplay.h>
#include <glint/GlintExceptions.h>
#include <gtest/gtest.h>

using namespace std;
using namespace glint;

TEST(GraphicsDisplay, basic)
{
    Runtime::Ptr rt = Runtime::create();
    GraphicsDisplay* gd = rt->create_display(100, 110, 120, 130);

    EXPECT_EQ(100, gd->width());
    EXPECT_EQ(110, gd->height());
    EXPECT_EQ(120, gd->xpos());
    EXPECT_EQ(130, gd->ypos());

    gd->make_current();
    gd->make_current();

    gd->release_current();
    gd->release_current();

    EXPECT_TRUE(gd->window());
}
